import javafx.animation.Timeline;
import javafx.animation.KeyFrame;
import javafx.util.Duration;
import java.lang.Math;

public class Drone  {
   public Drone () {
      state = State.LANDED;
      time=AppTime.getCurrentTime();
      fSpeed=vSpeed=sSpeed=rSpeed=0f;
      direction=0;
      x=150;  y=40;      h=0f;
      view = new DroneView();
      updateView();  // view shows drone model (its position, direction, etc).
      animation = new Timeline(new KeyFrame(Duration.millis(100), e->takeAction()));
      animation.setCycleCount(Timeline.INDEFINITE);
   }
   static {
      MAX_F_SPEED = MAX_S_SPEED = 50; // [cm/s]
      MAX_V_SPEED = 20;    // [cm/s]
      MAX_R_SPEED = (double)(0.25*Math.PI/2); // [rad/s]
      TAKEOFF_LANDING_SPEED = 20; // [cm/s]
   }
   public void takeAction(){
      double current_t = AppTime.getCurrentTime();
      //....
      updateView();
      time = current_t;
   }
   private void updateView() {
      // same as stage 1
   }
   public void setRotationSpeed(double percentage) {
      rSpeed = percentage*MAX_R_SPEED;
   }
   public void setFlightSpeed(double verPer, double forwPer, double sidePer) {
      vSpeed = verPer*MAX_V_SPEED;
      fSpeed = forwPer*MAX_F_SPEED;
      sSpeed = sidePer*MAX_S_SPEED;
   }
   public State getState() {
      return state;
   }
   public String toString() {
      return x + ", " + y + ", " + h +"," +state;
   }
   public void takeOff() {
      if (state==State.LANDED){
         state = State.TAKING_OFF;
         // ......
      }
   }
   public void land() {
      if (state!=State.LANDED)
         state = State.LANDING;
   }
   public DroneView getView() {
      return view;
   }
   public double getPosX() {
      return x;
   }
   public double getPosY() {
      return y;
   }
   public double getHeight() {
      return h;
   }
   public void play() {
      view.play();
   }
   Timeline animation;
   private DroneView view;
   private State state;
   private double time;
   private double fSpeed, vSpeed, sSpeed, rSpeed;
   private double direction; // angle
   private double x,y,h;
   private static double MAX_F_SPEED;
   private static double MAX_V_SPEED;
   private static double MAX_S_SPEED;
   private static double MAX_R_SPEED;
   private static double TAKEOFF_LANDING_SPEED;
}